#!/usr/local/bin/perl

$BASE_DIR = "users/";

# Read query string and store in $Form. Also set $type depending on the method
if($ENV{'REQUEST_METHOD'} eq "POST") {
  $type = "data_received";
  read(STDIN, $QueryString, $ENV{'CONTENT_LENGTH'});
} else {
  $type = "display_form";
  $QueryString = $ENV{QUERY_STRING};
}

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";

# Split the path for the current category
@category_list = split (/\//, $Form{path});

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);


if ( $type eq "display_form" ) {

    $check_dir_exists = `cd \"$BASE_DIR$Form{dest}\";pwd;`;

    chop ($check_dir_exists);

    if ( $check_dir_exists ne "$BASE_DIR$Form{dest}" ) {
        print "Content-type: text/html", "\n\n";
        print "<html><body><B>ERROR</B><BR>Destination category doesn't exist<BR><BR>$check_dir_exists - $BASE_DIR$Form{dest}";
        exit(0);
    }

# HTTP headers
    print "Content-type: text/html", "\n\n";
    print "<html><head>\n<script>\nfunction browse ( the_path ) {\ndocument.browse.dest.value = the_path;\ndocument.browse.submit();\n}</script></head><body>";

    dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

    $len_category_list = -1;
    foreach $category (@category_list) {
      $len_category_list++;
    }

    print "Source :<BR>";
    print "<TABLE WIDTH=\"100%\" BORDER=\"0\"><TR><TD>";

    $path_so_far = "";

    for ($i = 0; $i <= $len_category_list; $i++) {

      $temp = $category_list[$i];
      $temp =~ tr/ /+/;

      if ($i == 0) {
        $path_so_far = "$temp";
      } else {
        print " &gt; ";
        $path_so_far = "$path_so_far\/$temp";
      }

      print "<A HREF=\"display.pl?path=$path_so_far\"><B>$category_list[$i]</B></A>";

    }

    print "</TD></TR></TABLE>";

    $i = $Form{"entry_no"};
    $j = 0;

    print "<BR><TABLE BGCOLOR=\"#B8B8B8\" WIDTH=\"100%\" BORDER=\"1\">";
    while ($Config_global{"${j}_key"} ne "") {
        $key = $Config_global{"${j}_key"};
        $temp = $ENTRIES{"${i}_$key"};
#        if ($Config_global{"${j}_output"} ne "") {
#            $temp = eval "$Config_global{\"${j}_output\"} $temp";
#        }

#        $temp =~ s/\n/<BR>/g;
        print "<TR><TD WIDTH=\"20%\" BGCOLOR=\"#C0A784\"><B>$Config_global{\"${j}_name\"} :</B></TD><TD BGCOLOR=\"#FFFFCC\">";
        if ($Config_global{"${j}_key"} eq links) {
            print "<OL>";
            $link_num = 1;
            foreach $link (split (/\n/, $temp)) {

                $target = "${i}_$link_num";
                print "<LI><A HREF=\"$link\" TARGET=\"$target\">$link</A>";
                $link_num++;

            }

            print "</OL>";

        } else {
            $temp =~ s/\n/<BR>/g;
            print "$temp";
        }

        print "</TD></TR>";

        $j++;
    }

    print "</TABLE>";

    print "<BR><BR>Destination :<BR>";

    @category_list1 = split (/\//, $Form{dest});

    $len_category_list1 = -1;
    foreach $category (@category_list1) {
      $len_category_list1++;
    }

    print "<TABLE WIDTH=\"100%\" BORDER=\"0\"><TR><TD>";

    $path_so_far = "";

    for ($i = 0; $i <= $len_category_list1; $i++) {

      $temp = $category_list1[$i];
      $temp =~ tr/ /+/;

      if ($i == 0) {
        $path_so_far = "$temp";
      } else {
        print " &gt; ";
        $path_so_far = "$path_so_far\/$temp";
      }

      print "<A HREF=\"display.pl?path=$path_so_far\"><B>$category_list1[$i]</B></A>";

    }

    print "</TD></TR></TABLE><BR>";

    print "<FORM METHOD=\"post\" NAME=\"move\" ACTION=\"move_entry.pl\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"$Form{\"path\"}\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"entry_no\" VALUE=\"$Form{\"entry_no\"}\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"dest\" VALUE=\"$Form{\"dest\"}\">";
    print "<CENTER><INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"Move Now\">";
    print "</FORM>";

    print "<BR><B>OR</B><BR><BR></CENTER>";
    print "Type and click browse or select a path below for the destination category :<BR><BR>";

    print "<FORM METHOD=\"get\" NAME=\"browse\" ACTION=\"move_entry.pl\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"$Form{\"path\"}\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"entry_no\" VALUE=\"$Form{\"entry_no\"}\">";
    print "<INPUT TYPE=\"text\" NAME=\"dest\" VALUE=\"$Form{\"dest\"}\">";
    print "<A HREF=\"javascript:document.browse.submit();\">Browse</A>";
    print "</FORM>";

    print "<BR><BR>";

    $path_so_far = "";

    for ($i = 0; $i < $len_category_list1; $i++) {
      if ($i == 0) {
        $path_so_far = "$category_list1[$i]";
      } else {
        $path_so_far = "$path_so_far\/$category_list1[$i]";
      }
    }

    if ( $path_so_far ne "") {
        print "<A HREF=\"javascript:browse('$path_so_far');\">Up one level</A><BR><BR>";
        $path_so_far = "$path_so_far\/$category_list1[$len_category_list1]";
    } else {
        $path_so_far = "$category_list1[$len_category_list1]";
    }

# Get all directories in the category represented by the path $Form{dest}
    $output = `cd \"$BASE_DIR$Form{dest}\"; find * -type d -print | /usr/xpg4/bin/grep -E \"^[^\/]+\$\"`;

    foreach $directory (split (/\n/, $output)) {

      $temp_directory = $directory;
#      $temp_directory =~ tr/ /+/;

      print "<A HREF=\"javascript:browse('$path_so_far\/$temp_directory');\">$directory</A><BR>";

    }

} elsif ( $type eq "data_received" ) {

  if ( $Form{dest} eq $Form{path} ) {
    print "Content-type: text/html", "\n\n";
    print "<html><body><B>ERROR</B><BR>The source and destination categories you used are the same";
    exit(0);
  }

# Lock the destination category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &lock("$BASE_DIR$Form{dest}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to lock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to lock the category $Form{dest}.";
    exit(0);
  }


# Lock the source category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &lock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to lock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to lock the category $Form{path}.";
    exit(0);
  }


# Open the databases and find an unused key in the destination database
  dbmopen %ENTRIES_SRC, "$BASE_DIR$Form{path}\/entries", 0666;

  dbmopen %ENTRIES_DST, "$BASE_DIR$Form{dest}\/entries", 0666;

  $found_usable_key = 0;
  $new_key = 0;

  while ($found_usable_key == 0) {

    $temp = $ENTRIES_DST{"${new_key}_USED"};

    if ($temp eq "") {
        $found_usable_key = 1;
    } else {
        $new_key++;
    }
  }

  $i = $Form{"entry_no"};
  $j = 0;
  while ( $Config_global{"${j}_key"} ne "" ) {
    $key = $Config_global{"${j}_key"};
    $ENTRIES_DST{"${new_key}_$key"} = $ENTRIES_SRC{"${i}_$key"};
    delete $ENTRIES_SRC{"${i}_$key"};
    $j++;
  }

  $ENTRIES_DST{"${new_key}_USED"} = 1;

  delete $ENTRIES_SRC{"${i}_USED"};


# In case the deleted source key was the largest key
  if ( $i == $ENTRIES_SRC{"LARGEST_KEY"} ) {
    $current_largest_key = -1;
    for ( $j = 0; $j <= $i; $j++) {
        if ($ENTRIES_SRC{"${j}_USED"} == 1) {
            $current_largest_key = $j;
        }
    }

    if ( $current_largest_key == -1 ) {
        delete $ENTRIES_SRC{"LARGEST_KEY"};
    } else {
        $ENTRIES_SRC{"LARGEST_KEY"} = $current_largest_key;
    }
  }


# In case the new key for the destination is the largest key
  if ( ($ENTRIES_DST{"LARGEST_KEY"} eq "") || ($new_key > $ENTRIES_DST{"LARGEST_KEY"}) ) {
      $ENTRIES_DST{"LARGEST_KEY"} = $new_key;
  }

  dbmclose %ENTRIES_DST;

  dbmclose %ENTRIES_SRC;


# Unlock the source category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &unlock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to unlock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to unlock the category $Form{path}.";
    exit(0);
  }


# Unlock the destination category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &unlock("$BASE_DIR$Form{dest}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to unlock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to unlock the category $Form{dest}.";
    exit(0);
  }


# Display the category
  $the_path = $Form{dest};
  $the_path =~ tr/ /+/;
  print "Location: display.pl?path=$the_path", "\n\n";

}

# Subroutine to unlock the category
sub unlock {

  ($_) = @_;

  $output = `rm \"$_\/lock\"`;
  if (open(LOCK, "$_\/lock")) {
    close(LOCK);
    return 0;
  }

  return 1;
}

# Subroutine to lock the category
sub lock {

  ($_) = @_;

  if (open(LOCK, "$_\/lock")) {
    $time_of_lock = <LOCK>;
    $time = time();
    if ($time - $time_of_lock < 900) {
      close(LOCK);
      return 0;
    }
    close(LOCK);
  }

  open(LOCK, ">$_\/lock");

  $time = time();
  print LOCK "$time";

  close(LOCK);

  return 1;

}



#subroutine to parse a config file and store it as a hash.
#Takes 2 arguments - the config file and a reference to the hash

sub parse_config_file {

local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "<B>ERROR</B><BR>Config file not found : $category_list[0].config";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}




